#!/bin/sh

SNORT_INLINE=`grep "snort-inline=" /etc/packetprotector.conf | cut -d "=" -f 2`

if [ "X$SNORT_INLINE" = "X1" ] ; then
	
	echo "Snort-inline enabled.  Continuing..."

	if [ -s /packetprotector/etc/snort/oinkcode ] ; then

		echo "Oinkcode found!"

		OINKCODE=`cat /packetprotector/etc/snort/oinkcode | sed s/" "/""/g`
		export LD_LIBRARY_PATH=/packetprotector/usr/lib

		web_client_rule_count=250

		echo "Fetching VRT rules!"

		VRT_RULES=http://www.snort.org/pub-bin/oinkmaster.cgi/$OINKCODE/snortrules-snapshot-2.4.tar.gz

		mkdir /tmp/oink
		cd /tmp/oink

		wget $VRT_RULES || exit
		tar -zxvf snortrules-snapshot-2.4.tar.gz rules/web-client.rules > /dev/null 2> /dev/null
		tar -zxvf snortrules-snapshot-2.4.tar.gz rules/VRT-License.txt > /dev/null 2> /dev/null
		echo "Rules extracted!"

		if [ -s snortrules-snapshot-2.4.tar.gz ] ; then
			cd rules
			cp /packetprotector/etc/snort/snort-inline.conf .
			mkdir drop-rules

			cp VRT-License.txt drop-rules/

			### setup web-client rules
			grep -e "^alert" web-client.rules | tail -$web_client_rule_count | sed "s/^alert/drop/"  > drop-rules/web-client.rules
			grep "include \$RULE_PATH/web-client.rules" snort-inline.conf > /dev/null
			if [ $? = 0 ] ; then
				echo "web-client.rules found in snort-inline.conf"
			else
				echo "include \$RULE_PATH/web-client.rules" >> snort-inline.conf
			fi

			### copy to /tmp/drop-rules
			rm -rf /tmp/drop-rules.OLD
			rm -f /packetprotector/etc/snort/snort-inline.conf.OLD
			cp -r /tmp/drop-rules /tmp/drop-rules.OLD
			cp /packetprotector/etc/snort/snort-inline.conf /packetprotector/etc/snort/snort-inline.conf.OLD
			cp drop-rules/* /tmp/drop-rules
			cp snort-inline.conf /packetprotector/etc/snort/

			EPOCHTIME=`date +%s`
			LOGDIR="/var/log"
			mv $LOGDIR/snort-inline/alert $LOGDIR/snort-inline/alert.$EPOCHTIME && touch $LOGDIR/snort-inline/alert
			# restart
			killall snort-inline
			echo "Snort killed!"
			sleep 3
			echo "Restarting Snort!"
			/packetprotector/etc/init.d/S11snort-inline
			echo "Done!"
			# update timestamp
			date "+%a %b %d %H:%M:%S %Y" > /packetprotector/etc/snort/drop-rules/last_updated
		
		else
 			echo "Error fetching rules files!"

		fi

		cd
		rm -rf /tmp/oink

	else
		echo "Oinkcode not found!"

	fi

fi
