#!/bin/bash

echo "#Config file for L2TPns" > /etc/l2tpns/startup-config
echo "#Generated by X-WRT" >> /etc/l2tpns/startup-config

bindaddr=`uci get l2tpns.cfg1.ipaddr`
debug=`uci get l2tpns.cfg1.debug`
radport=`uci get l2tpns.cfg1.radport`
radacct=`uci get l2tpns.cfg1.radacct`
pidfile=`uci get l2tpns.cfg1.pidfile`
logfile=`uci get l2tpns.cfg1.logfile`
pdns=`uci get l2tpns.cfg1.dns1`
sdns=`uci get l2tpns.cfg1.dns2`
prad=`uci get l2tpns.cfg1.rad1`
srad=`uci get l2tpns.cfg1.rad2`
radsecret=`uci get l2tpns.cfg1.radsecret`

echo "debug $debug" >> /etc/l2tpns/startup-config
echo "log_file $logfile" >> /etc/l2tpns/startup-config
echo "pid_file $pidfile" >> /etc/l2tpns/startup-config
echo "primary_radius $prad" >> /etc/l2tpns/startup-config
echo "secondary_radius $srad" >> /etc/l2tpns/startup-config
# for now we're applying to both the primary and secondary
# radius servers the same port number for auth
echo "primary_radius_port $radport" >> /etc/l2tpns/startup-config
echo "secondary_radius_port $radport" >> /etc/l2tpns/startup-config
echo "radius_accounting $radacct" >> /etc/l2tpns/startup-config
echo "radius_secret $radsecret" >> /etc/l2tpns/startup-config
echo "primary_dns $pdns" >> /etc/l2tpns/startup-config
echo "secondary_dns $sdns" >> /etc/l2tpns/startup-config
echo "bind_address $bindaddr" >> /etc/l2tpns/startup-config

/etc/init.d/l2tpns restart
